class Is {
    static callToString(arg) {
        return Object.prototype.toString.call(arg)
    };

    static $string(arg) {
        return Is.callToString(arg) === '[object String]';
    };

    static is(arg, type){
        if (!Is.$string(type)) throw new Error('The "type" must be a String');
        let response = Is.callToString(arg) === `[object  ${type}]`;
        if (!response) response = eval(`arg instanceof ${type}`);
        return response;
    };

    static $array(arg){
        return Is.is(arg, 'Array');
    };

    static $null(arg){
        return Is.is(arg, 'Null');
    };

    static $number(arg){
        return Is.is(arg, 'Number');
    };

    static $object(arg){
        return Is.is(arg, 'Object');
    };

    static $undefined(arg){
        return Is.is(arg, 'Undefined');
    };

    static $boolean(arg){
        return Is.is(arg, 'Boolean');
    };

    static $function(arg){
        return Is.is(arg, 'Function');
    };
}

module.exports = Is;